// pmMeshPaintPlugin

function XSILoadPlugin( in_reg )
{
	in_reg.Author = "piotrek marczak";
	in_reg.Name = "pmMeshPaintPPG_Plugin";
	in_reg.Major = 1;
	in_reg.Minor = 0;

	in_reg.RegisterProperty("pmMeshPaintPPG");
	//RegistrationInsertionPoint - do not remove this line

	return true;
}

function XSIUnloadPlugin( in_reg )
{
	var strPluginName;
	strPluginName = in_reg.Name;
	Application.LogMessage(strPluginName + " has been unloaded.",siVerbose);
	return true;
}

function pmMeshPaintPPG_Define( in_ctxt )
{
	var oCustomProperty;
	oCustomProperty = in_ctxt.Source;
	oCustomProperty.AddParameter2("Logo",siString,"",null,null,null,null,siClassifUnknown,siPersistable);
	oCustomProperty.AddParameter2("LogoRandomize",siString,"",null,null,null,null,siClassifUnknown,siPersistable);
	oCustomProperty.AddParameter2("LogoObjList",siString,"",null,null,null,null,siClassifUnknown,siPersistable);
	oCustomProperty.AddParameter2("Paint_Mode",siInt4,0,0,1,0,1,siClassifUnknown,siPersistable, "Paint Mode");
	oCustomProperty.AddParameter2("Align_To_Surface",siBool,true,null,null,null,null,siClassifUnknown,siPersistable,"Align To Surface");
	oCustomProperty.AddParameter2("FollowStroke",siBool,false,null,null,null,null,siClassifUnknown,siPersistable,"Follow Stroke");
	oCustomProperty.AddParameter2("StrokeSmoothLength",siDouble,2.0,0,1000,0,10,siClassifUnknown,siPersistable,"Stroke Smoooth");	
	oCustomProperty.AddParameter2("AlignAxis",siInt4,1,0,2,0,2,siClassifUnknown,siPersistable, "Align Axis");
	oCustomProperty.AddParameter2("AlignAxisFlip",siBool,false,null,null,null,null,siClassifUnknown,siPersistable,"Flip Axis");
	oCustomProperty.AddParameter2("CloneCount",siInt4,1,1,500,1,30,siClassifUnknown,siPersistable, "Max. Clone Count");
	oCustomProperty.AddParameter2("axisoffsetX",siDouble,0,-10000,10000,-3,3,siClassifUnknown,siPersistable,"X");
	oCustomProperty.AddParameter2("axisoffsetY",siDouble,0,-10000,10000,-3,3,siClassifUnknown,siPersistable,"Y");
	oCustomProperty.AddParameter2("axisoffsetZ",siDouble,0,-10000,10000,-3,3,siClassifUnknown,siPersistable,"Z");
	oCustomProperty.AddParameter2("scaleramp",siBool,false,null,null,null,null,siClassifUnknown,siPersistable,"Ramp Scale");
	oCustomProperty.AddParameter2("scalerampuni",siBool,true,null,null,null,null,siClassifUnknown,siPersistable,"Uniform Scale");
	oCustomProperty.AddParameter2("scaleminx",siDouble,0.1,0,1000,0,10,siClassifUnknown,siPersistable,"X");
	oCustomProperty.AddParameter2("scaleminy",siDouble,0.1,0,1000,0,10,siClassifUnknown,siPersistable,"Y");
	oCustomProperty.AddParameter2("scaleminz",siDouble,0.1,0,1000,0,10,siClassifUnknown,siPersistable ,"Z");
	oCustomProperty.AddParameter2("scalex",siDouble,1,0,1000,0,10,siClassifUnknown,siPersistable,"X");
	oCustomProperty.AddParameter2("scaley",siDouble,1,0,1000,0,10,siClassifUnknown,siPersistable,"Y");
	oCustomProperty.AddParameter2("scalez",siDouble,1,0,1000,0,10,siClassifUnknown,siPersistable,"Z");
	oCustomProperty.AddParameter2("rotoffsetx",siDouble,0,0,360,0,100,siClassifUnknown,siPersistable,"X");
	oCustomProperty.AddParameter2("rotoffsety",siDouble,0,0,360,0,100,siClassifUnknown,siPersistable,"Y");
	oCustomProperty.AddParameter2("rotoffsetz",siDouble,0,0,360,0,100,siClassifUnknown,siPersistable,"Z");
	oCustomProperty.AddParameter2("paintinstances",siBool,true,null,null,null,null,siClassifUnknown,siPersistable,"Paint Instances");
	oCustomProperty.AddParameter2("interpolateposition",siBool,false,null,null,null,null,siClassifUnknown,siPersistable,"Interpolate Mouse Position (SLOW!)");
	oCustomProperty.AddParameter2("paint_on_selection_only",siBool,false,null,null,null,null,siClassifUnknown,siPersistable,"Paint On Selection Only");
	oCustomProperty.AddParameter2("stackclones",siBool,false,null,null,null,null,siClassifUnknown,siPersistable,"Stack Clones");
	//oCustomProperty.AddParameter2("collisions",siBool,false,null,null,null,null,siClassifUnknown,siPersistable,"Collision Testing");
	//oCustomProperty.AddParameter2("updatemode",siInt4,0,0,1,0,1,siClassifUnknown,siPersistable,"Update Mode");
	//oCustomProperty.AddParameter2("builduptime",siDouble,100,10,2360,10,500,siClassifUnknown,siPersistable | siNotInspectable,"Update Time (ms)");
	oCustomProperty.AddParameter2("buildupdist",siDouble,1,0,2000,5,20,siClassifUnknown,siPersistable,"Spacing (SI units)");
	oCustomProperty.AddParameter2("randseed",siInt4,12536,0,111360,0,20000,siClassifUnknown,siPersistable,"Seed");
	oCustomProperty.AddParameter2("randrotx",siDouble,0,0,360,0,100,siClassifUnknown,siPersistable,"X");
	oCustomProperty.AddParameter2("randroty",siDouble,0,0,360,0,100,siClassifUnknown,siPersistable,"Y");
	oCustomProperty.AddParameter2("randrotz",siDouble,0,0,360,0,100,siClassifUnknown,siPersistable,"Z");
	oCustomProperty.AddParameter2("randscluni",siBool,true,null,null,null,null,siClassifUnknown,siPersistable,"Uniform Scale");
	oCustomProperty.AddParameter2("randsclrange",siBool,false,null,null,null,null,siClassifUnknown,siPersistable,"Allow negative scaling");
	
	oCustomProperty.AddParameter2("randsclx",siDouble,0,0,10000,0,10,siClassifUnknown,siPersistable,"X");
	oCustomProperty.AddParameter2("randscly",siDouble,0,0,10000,0,10,siClassifUnknown,siPersistable,"Y");
	oCustomProperty.AddParameter2("randsclz",siDouble,0,0,10000,0,10,siClassifUnknown,siPersistable,"Z");
	oCustomProperty.AddParameter2("randposx",siDouble,0,0,10000,0,10,siClassifUnknown,siPersistable,"X");
	oCustomProperty.AddParameter2("randposy",siDouble,0,0,10000,0,10,siClassifUnknown,siPersistable,"Y");
	oCustomProperty.AddParameter2("randposz",siDouble,0,0,10000,0,10,siClassifUnknown,siPersistable,"Z");
	oCustomProperty.AddParameter2("paintselected",siBool,false,null,null,null,null,siClassifUnknown,siPersistable,"Paint only list selection");
	oCustomProperty.AddParameter2("paintgrid",siBool,true,null,null,null,null,siClassifUnknown,siPersistable,"Paint On Grid");
	oCustomProperty.AddParameter2("highlightpolysel",siBool,true,null,null,null,null,siClassifUnknown,siPersistable,"Highlight Poly Selection");
	
	oCustomProperty.AddParameter2("randlocalTrans",siBool,false,null,null,null,null,siClassifUnknown,siPersistable,"Local translation");

	oCustomProperty.AddParameter("objList",siString);

	oCustomProperty.AddParameter2("groupName", siString, "",null,null,null,null,siClassifUnknown,siPersistable, "Add to Group");
	oCustomProperty.AddParameter2("nullName", siString, "",null,null,null,null ,siClassifUnknown,siPersistable,"Parent to Null");
	
	oCustomProperty.AddParameter2("listpick",siInt4,0,0,2,0,2,siClassifUnknown,siPersistable, "List pick");

	oCustomProperty.AddParameter2("DeleteOverlaps",siBool,true,null,null,null,null,siClassifUnknown,siPersistable,"Delete overlapping");
	oCustomProperty.AddParameter2("BBoxScale",siDouble,0.6,0,1,0,1,siClassifUnknown,siPersistable,"Bounding Box Scale");

	return true;
}

function pmMeshPaintPPG_DefineLayout( in_ctxt )
{
	var oLayout,oItem;
	oLayout = in_ctxt.Source;
	oLayout.Clear();
	
	var oPlugin = Application.Plugins("pmMeshPaintToolPlugin");
	oPluginPath = oPlugin.OriginPath;
	oLogoPath = oPluginPath;
	oLogoPath = oLogoPath.replace("Application","Data");
	oLogoPath = oLogoPath.replace("Plugins","Images");
	
	Application.LogMessage(oLogoPath);

	oLayout.AddTab("General");
		oLayout.AddRow();
			oPaintButton = oLayout.AddButton("Paint");	oPaintButton.SetAttribute(siUICX, '55')	;	oPaintButton.SetAttribute(siUICY, '65')
			//oLayout.AddButton("AdjustValues");
		
			oLogo = oLayout.AddItem("Logo","", "BitmapWidget")
			oLogo.SetAttribute("path",oLogoPath + "\\Logo.bmp")
			oLogo.SetAttribute("NoLabel",1)
			oLogo.SetAttribute("CX",280)
			oLogo.SetAttribute("CY",65)	
		oLayout.EndRow();
	
		oLayout.AddGroup("General");
			var items = Array("Brush",0,"Drop",1);
			oLayout.AddEnumControl("Paint_Mode",items);
			oLayout.AddGroup("Alignment");
				oLayout.AddItem("Align_To_Surface");
				oLayout.AddItem("FollowStroke");
				var p = oLayout.AddItem("StrokeSmoothLength");p.SetAttribute(siUILabelMinPixels,125);p.SetAttribute(siUILabelPercentage,52);
				var items = Array("Axis X",0,"Axis Y",1,"Axis Z",2);
				p = oLayout.AddEnumControl("AlignAxis",items);p.SetAttribute(siUILabelMinPixels,125);p.SetAttribute(siUILabelPercentage,52);
				
				oLayout.AddItem("AlignAxisFlip");
			oLayout.EndGroup();
			
			p=oLayout.AddItem("buildupdist");p.SetAttribute(siUILabelMinPixels,125);p.SetAttribute(siUILabelPercentage,52);
			p=oLayout.AddItem("CloneCount");p.SetAttribute(siUILabelMinPixels,125);p.SetAttribute(siUILabelPercentage,52);
		oLayout.EndGroup();
		
		oLayout.AddGroup("Adjust");
		oLayout.AddSpacer(00,10);oLayout.AddRow();
			oLayout.AddGroup("Position");
				
					var p=oLayout.AddItem("axisoffsetX");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);				
					p=oLayout.AddItem("axisoffsetY");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);			
					p=oLayout.AddItem("axisoffsetZ");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
				
			oLayout.EndGroup();
		
			oLayout.AddGroup("Rotation");
				
					p=oLayout.AddItem("rotoffsetx");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
					p=oLayout.AddItem("rotoffsety");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
					p=oLayout.AddItem("rotoffsetz");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
				
			oLayout.EndGroup();oLayout.EndRow();
			oLayout.AddGroup("Scale");
				oLayout.AddItem("scaleramp");	
				oLayout.AddItem("scalerampuni");
			oLayout.AddRow();
				oLayout.AddGroup("Min. Scale");
				
						p=oLayout.AddItem("scaleminx");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
						p=oLayout.AddItem("scaleminy");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
						p=oLayout.AddItem("scaleminz");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
					
				oLayout.EndGroup();
				oLayout.AddGroup("Max. Scale");
					p=oLayout.AddItem("scalex");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
					p=oLayout.AddItem("scaley");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
					p=oLayout.AddItem("scalez");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
				oLayout.EndGroup();
				oLayout.EndRow();
			oLayout.EndGroup();		
		
			oLayout.AddSpacer(00,10);
		oLayout.EndGroup();
		oLayout.AddGroup("Options");
			oLayout.AddItem("stackclones");
			oLayout.AddItem("paintinstances");
			oLayout.AddItem("interpolateposition");
			oLayout.AddItem("paint_on_selection_only");
			oLayout.AddItem("paintgrid");
			oLayout.AddItem("highlightpolysel");
			oLayout.AddGroup("Grouping");
				oLayout.AddRow();
					p=oLayout.AddItem("groupName");p.SetAttribute(siUILabelMinPixels,75);p.SetAttribute(siUILabelPercentage,25);
					oPPGItem = oLayout.AddButton( "PickGroup", "Pick..." );					
				oLayout.EndRow();
				oLayout.AddRow();
					p=oLayout.AddItem("nullName");p.SetAttribute(siUILabelMinPixels,75);p.SetAttribute(siUILabelPercentage,25);
					oPPGItem = oLayout.AddButton( "PickNull", "Pick..." ) ;
				oLayout.EndRow();
			oLayout.EndGroup();	
			oLayout.AddGroup("Keep Apart");
			oLayout.AddItem("DeleteOverlaps");
			oLayout.AddItem("BBoxScale");
			oLayout.EndGroup();
			
		oLayout.EndGroup();
		oLayout.AddTab("Randomization");
			oLayout.AddRow();
				oPaintButton = oLayout.AddButton("Paint");	oPaintButton.SetAttribute(siUICX, '55')	;	oPaintButton.SetAttribute(siUICY, '65')
				//oLayout.AddButton("AdjustValues");
			
				oLogo = oLayout.AddItem("LogoRandomize","", "BitmapWidget")
				oLogo.SetAttribute("path",oLogoPath + "\\randomize.bmp")
				oLogo.SetAttribute("NoLabel",1)
				oLogo.SetAttribute("CX",280)
				oLogo.SetAttribute("CY",65)	
			oLayout.EndRow();
			oLayout.AddGroup("Randomize");	
				oLayout.AddSpacer(00,10);	
				oLayout.AddItem("randseed");	
				oLayout.AddGroup("Position");
					oLayout.AddItem("randlocalTrans");
					oLayout.AddRow();
						p=oLayout.AddItem("randposx");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
						p=oLayout.AddItem("randposy");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
						p=oLayout.AddItem("randposz");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
					oLayout.EndRow();
				oLayout.EndGroup();
				oLayout.AddGroup("Rotation");
					oLayout.AddRow();
						p=oLayout.AddItem("randrotx");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
						p=oLayout.AddItem("randroty");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
						p=oLayout.AddItem("randrotz");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
					oLayout.EndRow();
				oLayout.EndGroup();
				oLayout.AddGroup("Scale");
					oLayout.AddItem("randscluni");
					oLayout.AddItem("randsclrange");
					oLayout.AddRow();
						
						p=oLayout.AddItem("randsclx");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
						p=oLayout.AddItem("randscly");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
						p=oLayout.AddItem("randsclz");p.SetAttribute(siUILabelMinPixels,5);p.SetAttribute(siUILabelPercentage,5);
					oLayout.EndRow();
				oLayout.EndGroup();
			oLayout.AddSpacer(00,10);
			oLayout.EndGroup();
	oLayout.AddTab("ObjectList");
		oLayout.AddRow();
			oPaintButton = oLayout.AddButton("Paint");	oPaintButton.SetAttribute(siUICX, '55')	;	oPaintButton.SetAttribute(siUICY, '65')
			//oLayout.AddButton("AdjustValues");
		
			oLogo = oLayout.AddItem("LogoObjList","", "BitmapWidget")
			oLogo.SetAttribute("path",oLogoPath + "\\objlist.bmp")
			oLogo.SetAttribute("NoLabel",1)
			oLogo.SetAttribute("CX",280)
			oLogo.SetAttribute("CY",65)	
		oLayout.EndRow();
		oLayout.AddGroup("Object List");
				oLayout.AddItem("paintselected");
				var items = Array("Random",0,"Cycle thru list",1);
				oLayout.AddEnumControl("listpick",items);
				AddListBox( oLayout, "objList") ;	
				oLayout.AddRow();
					oButton = oLayout.AddButton("AddSelection","Add Selection");
					oButton.SetAttribute(siUICX, '125');		
					oButton.SetAttribute(siUICY, '35');
					oButton = oLayout.AddButton("Remove","Remove from list");
					oButton.SetAttribute(siUICX, '125');			
					oButton.SetAttribute(siUICY, '35');
				oLayout.EndRow();

		oLayout.EndGroup();				

	return true;
}
function AddListBox( in_oLayout, in_Name )
{
        var oItem = in_oLayout.AddItem( in_Name, "", "ListBox" ) ;
        oItem.SetAttribute( "CY", 300 ) ;
        oItem.SetAttribute( "NoLabel", true ) ;
        oItem.SetAttribute( siUIMultiSelectionListBox, true ) ;
		
}
function grayOut()
{	
	if (PPG.stackclones == 1)
		PPG.interpolateposition.ReadOnly = true;
	else
		PPG.interpolateposition.ReadOnly = false;
	if (PPG.Paint_Mode.Value == 1)	{	//drop
		PPG.FollowStroke.ReadOnly = true;
		PPG.StrokeSmoothLength.ReadOnly = true;
		PPG.buildupdist.ReadOnly = true;
		PPG.CloneCount.ReadOnly = true;
		PPG.scaleramp.ReadOnly = true;
		PPG.stackclones.ReadOnly = true;
		PPG.interpolateposition.ReadOnly = true;
		PPG.DeleteOverlaps.ReadOnly = true;
	}
	else	{
		PPG.FollowStroke.ReadOnly = false;
		PPG.StrokeSmoothLength.ReadOnly = false;
		PPG.buildupdist.ReadOnly = false;
		PPG.CloneCount.ReadOnly = false;
		PPG.scaleramp.ReadOnly = false;
		
		PPG.stackclones.ReadOnly = false;
		if( PPG.stackclones == 0 )
			PPG.interpolateposition.ReadOnly = false;
		PPG.DeleteOverlaps.ReadOnly = false;
	}

}
function pmMeshPaintPPG_OnInit( )
{
	grayOut();
}

function pmMeshPaintPPG_Paint_Mode_OnChanged()
{
	grayOut();
}
function pmMeshPaintPPG_stackclones_OnChanged()
{
	grayOut();
}
function pmMeshPaintPPG_randscluni_OnChanged()
{
	var param = PPG.randscluni;
	if (param.Value == true){
		var paramx = PPG.randsclx;
		PPG.randscly.Value = paramx.Value;
		PPG.randsclz.Value = paramx.Value;
	}
}
function pmMeshPaintPPG_scalerampuni_OnChanged()
{
	var param = PPG.scalerampuni;
	if (param.Value == true){
		var paramx = PPG.scaleminx;
		PPG.scaleminy.Value = paramx.Value;
		PPG.scaleminz.Value = paramx.Value;
		var paramx = PPG.scalex;
		PPG.scaley.Value = paramx.Value;
		PPG.scalez.Value = paramx.Value;
	}
}
function pmMeshPaintPPG_scalex_OnChanged()
{
	var param = PPG.scalerampuni;
	if (param.Value == true){
		var paramx = PPG.scalex;
		PPG.scaley.Value = paramx.Value;
		PPG.scalez.Value = paramx.Value;
	}
}
function pmMeshPaintPPG_scaley_OnChanged()
{
	var param = PPG.scalerampuni;
	if (param.Value == true){
		var paramx = PPG.scaley;
		PPG.scalex.Value = paramx.Value;
		PPG.scalez.Value = paramx.Value;
	}
}
function pmMeshPaintPPG_scalez_OnChanged()
{
	var param = PPG.scalerampuni;
	if (param.Value == true){
		var paramx = PPG.scalez;
		PPG.scaley.Value = paramx.Value;
		PPG.scalex.Value = paramx.Value;
	}
}
function pmMeshPaintPPG_scaleminx_OnChanged()
{
	var param = PPG.scalerampuni;
	if (param.Value == true){
		var paramx = PPG.scaleminx;
		PPG.scaleminy.Value = paramx.Value;
		PPG.scaleminz.Value = paramx.Value;
	}
}
function pmMeshPaintPPG_scaleminy_OnChanged()
{
	var param = PPG.scalerampuni;
	if (param.Value == true){
		var paramx = PPG.scaleminy;
		PPG.scaleminx.Value = paramx.Value;
		PPG.scaleminz.Value = paramx.Value;
	}
}
function pmMeshPaintPPG_scaleminz_OnChanged()
{
	var param = PPG.scalerampuni;
	if (param.Value == true){
		var paramx = PPG.scaleminz;
		PPG.scaleminx.Value = paramx.Value;
		PPG.scaleminy.Value = paramx.Value;
	}
}
function pmMeshPaintPPG_randsclx_OnChanged()
{
	var param = PPG.randscluni;
	if (param.Value == true){
		var paramx = PPG.randsclx;
		PPG.randscly.Value = paramx.Value;
		PPG.randsclz.Value = paramx.Value;
	}
}
function pmMeshPaintPPG_randscly_OnChanged()
{
	var param = PPG.randscluni;
	if (param.Value == true){
		var paramx = PPG.randscly;
		PPG.randsclx.Value = paramx.Value;
		PPG.randsclz.Value = paramx.Value;
	}
}
function pmMeshPaintPPG_randsclz_OnChanged()
{
	var param = PPG.randscluni;
	if (param.Value == true){
		var paramx = PPG.randsclz;
		PPG.randsclx.Value = paramx.Value;
		PPG.randscly.Value = paramx.Value;
	}
}
function pmMeshPaintPPG_updatemode_OnChanged()
{
	var param = PPG.updatemode;
	var paramBdist = PPG.buildupdist;
	var paramBtime = PPG.builduptime;
	if (param.Value == 0)	{
		paramBdist.SetCapabilityFlag( siNotInspectable, false);
		paramBtime.SetCapabilityFlag( siNotInspectable, true);
	}
	else	{
		paramBdist.SetCapabilityFlag( siNotInspectable, true);
		paramBtime.SetCapabilityFlag( siNotInspectable, false);
	}
	PPG.Refresh();
}

function pmMeshPaintPPG_OnClosed( )
{

}

function pmMeshPaintPPG_Paint_OnClicked( )
{
	
	Application.SetGlobal("pmMeshPaintPPG_GlobalPPG_Link",PPG.Inspected(0));
	pmMeshPaint();
}

function pmMeshPaintPPG_PickGroup_OnClicked( )
{
	ActivateObjectSelTool(null);
	var aRtn = PickObject( "Select Object", "Select Group" )
	var buttonChoice = aRtn.Value( "ButtonPressed" ) ;
    if ( buttonChoice != 0 ) 
	{
		var picked = aRtn.Value( "PickedElement" );
		if (picked.Type == "#Group")
			PPG.groupName.Value = aRtn.Value( "PickedElement" );
		else	
			Application.Logmessage("Please pick group!");
	}
	
}

function pmMeshPaintPPG_PickNull_OnClicked( )
{
	ActivateObjectSelTool(null);
	var aRtn = PickObject( "Select Object", "Select Null" )
	var buttonChoice = aRtn.Value( "ButtonPressed" ) ;
    if ( buttonChoice != 0 ) 
	{
		var picked = aRtn.Value( "PickedElement" );
		if (picked.Type == "null")
			PPG.nullName.Value = aRtn.Value( "PickedElement" );
		else
			Application.Logmessage("Please pick null!");
	}
}
function pmMeshPaintPPG_Remove_OnClicked( )
{
	var oItem = PPG.PPGLayout.Item("objList");
	var vbItems = new VBArray( oItem.UIItems );
	var listItems = vbItems.toArray();
	strsel = PPG.Inspected(0).Parameters("objList").Value;
	if (strsel == "")
		return;
	splitSel = strsel.split(";");
	var outItems = new Array ();
	
	for( i = 0; i < listItems.length; i++)
	{
		var bnotAdd = false;
		for ( j = 0 ; j < splitSel.length ; j++ )
		{		
			if ( splitSel[j] == listItems[i] )
			{				
				bnotAdd = true;
				break;
			}
		}
		if (! bnotAdd ){
			outItems[outItems.length] = listItems[i];		
			}		
	}
	oItem.UIItems = outItems;
	if ( outItems.length > 0 )
		PPG.Inspected(0).Parameters("objList").Value = outItems[0];
	else
		PPG.Inspected(0).Parameters("objList").Value = "" ;
        
	PPG.Refresh();
}
function pmMeshPaintPPG_AddSelection_OnClicked( )
{
	var oItem = PPG.PPGLayout.Item("objList");
	var vbItems = new VBArray( oItem.UIItems );
	var listItems = vbItems.toArray();

	aItems = Selection;
	var coll = new ActiveXObject("XSI.Collection") ;
	for (var i=0;i< listItems.length;i+=2)	{
		var obj = Dictionary.GetObject( listItems[i], false);	//check if object exists...
		if ( obj != null)
			coll.Add(listItems[i]);
	}	
	
	
	for (var i=0;i < aItems.Count;i++)	{
		var type = aItems(i).Type;
		// collection filter didn't work...dont have time to check why, so therefore lame object testing:
		if (type == "polymsh" || type == "#Group" || type == "#model" || type == "null" || type == "surfmsh" || type == "light" ||
		type == "crvlist" || type == "GeoShader" || type == "standin" || type == "square" || type == "spiral" || type == "grid" ||
		type == "disc" || type == "cylinder" || type == "cube" || type == "cone" || type == "bone" || type == "circle" ||
		type == "bone" || type == "pointcloud" || type == "arc" || type == "fan" || type == "drag" || type == "lattice" ||
		type == "wind" || type == "Toric_Force" || type == "turbulence" || type == "vortex" || type == "gravity" || type == "attractor" ||
		type == "eddy" || type == "camera" || type == "CameraRoot" || type == "SpotRoot" || type == "SpotInterest" || type == "CameraInterest" ||
		type == "torus" || type == "sphere" || type == "Texture Support" 
)
		{	
			var foundItem = false; 
			for(var j=0; j < coll.Count;j++)			
				if ( coll(j).Name == aItems(i) )	{
					foundItem = true;	
					break;
				}
			
			if (!foundItem)
				coll.Add( aItems(i) );
		}
	}
	
	var outItems = new Array (coll.Count * 2);
	for (i=0;i<coll.Count;i++)	{
		outItems[i*2] = coll(i).Name;
		outItems[i*2+1] = coll(i).Name;
	}
	
	oItem.UIItems = outItems;
	PPG.Refresh();
}
function pmMeshPaintPPG_AdjustValues_OnClicked( )
{
	
}
